diff -Nur linux-2.4.30/drivers/i2c/i2c-au1550.c linux-2.4.30-linux-mips.org/drivers/i2c/i2c-au1550.c
--- linux-2.4.30/drivers/i2c/i2c-au1550.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/i2c/i2c-au1550.c	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,157 @@
+/*
+ * i2c-au1550.c: SMBus (i2c) adapter for Alchemy PSC interface
+ * Copyright (C) 2004 Embedded Edge, LLC <dan@embeddededge.com>
+ *
+ * This is just a skeleton adapter to use with the Au1550 PSC
+ * algorithm.  It was developed for the Pb1550, but will work with
+ * any Au1550 board that has a similar PSC configuration.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ */
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/errno.h>
+
+#include <asm/au1000.h>
+#include <asm/au1xxx_psc.h>
+#if defined( CONFIG_MIPS_PB1550 )
+	#include <asm/pb1550.h>
+#endif
+#if defined( CONFIG_MIPS_DB1550 )
+	#include <asm/db1x00.h>
+#endif
+#if defined( CONFIG_MIPS_PB1200 )
+	#include <asm/pb1200.h>
+#endif
+#if defined( CONFIG_MIPS_DB1200 )
+	#include <asm/db1200.h>
+#endif
+#if defined( CONFIG_MIPS_FICMMP )
+	#include <asm/ficmmp.h>
+#endif
+
+#include <linux/i2c.h>
+#include <linux/i2c-algo-au1550.h>
+
+
+
+static int
+pb1550_reg(struct i2c_client *client)
+{
+	return 0;
+}
+
+static int
+pb1550_unreg(struct i2c_client *client)
+{
+	return 0;
+}
+
+static void
+pb1550_inc_use(struct i2c_adapter *adap)
+{
+#ifdef MODULE
+	MOD_INC_USE_COUNT;
+#endif
+}
+
+static void
+pb1550_dec_use(struct i2c_adapter *adap)
+{
+#ifdef MODULE
+	MOD_DEC_USE_COUNT;
+#endif
+}
+
+static struct i2c_algo_au1550_data pb1550_i2c_info = {
+	SMBUS_PSC_BASE, 200, 200
+};
+
+static struct i2c_adapter pb1550_board_adapter = {
+	name:              "pb1550 adapter",
+	id:                I2C_HW_AU1550_PSC,
+	algo:              NULL,
+	algo_data:         &pb1550_i2c_info,
+	inc_use:           pb1550_inc_use,
+	dec_use:           pb1550_dec_use,
+	client_register:   pb1550_reg,
+	client_unregister: pb1550_unreg,
+	client_count:      0,
+};
+
+int __init
+i2c_pb1550_init(void)
+{
+	/* This is where we would set up a 50MHz clock source
+	 * and routing.  On the Pb1550, the SMBus is PSC2, which
+	 * uses a shared clock with USB.  This has been already
+	 * configured by Yamon as a 48MHz clock, close enough
+	 * for our work.
+	 */
+        if (i2c_au1550_add_bus(&pb1550_board_adapter) < 0)
+                return -ENODEV;
+
+	return 0;
+}
+
+/* BIG hack to support the control interface on the Wolfson WM8731
+ * audio codec on the Pb1550 board.  We get an address and two data
+ * bytes to write, create an i2c message, and send it across the
+ * i2c transfer function.  We do this here because we have access to
+ * the i2c adapter structure.
+ */
+static struct i2c_msg wm_i2c_msg;  /* We don't want this stuff on the stack */
+static	u8 i2cbuf[2];
+
+int
+pb1550_wm_codec_write(u8 addr, u8 reg, u8 val)
+{
+	wm_i2c_msg.addr = addr;
+	wm_i2c_msg.flags = 0;
+	wm_i2c_msg.buf = i2cbuf;
+	wm_i2c_msg.len = 2;
+	i2cbuf[0] = reg;
+	i2cbuf[1] = val;
+
+	return pb1550_board_adapter.algo->master_xfer(&pb1550_board_adapter, &wm_i2c_msg, 1);
+}
+
+/* the next function is needed by DVB driver. */
+int pb1550_i2c_xfer(struct i2c_msg msgs[], int num)
+{
+    return pb1550_board_adapter.algo->master_xfer(&pb1550_board_adapter, msgs, num);
+}
+
+EXPORT_SYMBOL(pb1550_wm_codec_write);
+EXPORT_SYMBOL(pb1550_i2c_xfer);
+
+MODULE_AUTHOR("Dan Malek, Embedded Edge, LLC.");
+MODULE_DESCRIPTION("SMBus adapter Alchemy pb1550");
+MODULE_LICENSE("GPL");
+
+int
+init_module(void)
+{
+	return i2c_pb1550_init();
+}
+
+void
+cleanup_module(void)
+{
+	i2c_au1550_del_bus(&pb1550_board_adapter);
+}
diff -Nur linux-2.4.30/drivers/i2c/i2c-core.c linux-2.4.30-linux-mips.org/drivers/i2c/i2c-core.c
--- linux-2.4.30/drivers/i2c/i2c-core.c	2005-01-19 15:09:54.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/i2c/i2c-core.c	2005-05-12 17:57:22.000000000 +0200
@@ -1280,6 +1280,9 @@
 #ifdef CONFIG_I2C_MAX1617
 	extern int i2c_max1617_init(void);
 #endif
+#ifdef CONFIG_I2C_ALGO_AU1550
+	extern int i2c_pb1550_init(void);
+#endif
 
 #ifdef CONFIG_I2C_PROC
 	extern int sensors_init(void);
@@ -1335,6 +1338,10 @@
 	i2c_max1617_init();
 #endif
 
+#ifdef CONFIG_I2C_ALGO_AU1550
+	i2c_pb1550_init();
+#endif
+
 	/* -------------- proc interface ---- */
 #ifdef CONFIG_I2C_PROC
 	sensors_init();
diff -Nur linux-2.4.30/drivers/i2c/Makefile linux-2.4.30-linux-mips.org/drivers/i2c/Makefile
--- linux-2.4.30/drivers/i2c/Makefile	2004-02-18 14:36:31.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/i2c/Makefile	2005-05-12 17:57:22.000000000 +0200
@@ -6,7 +6,7 @@
 
 export-objs	:= i2c-core.o i2c-algo-bit.o i2c-algo-pcf.o \
 		   i2c-algo-ite.o i2c-algo-sibyte.o i2c-algo-sgi.o \
-		   i2c-proc.o
+		   i2c-algo-au1550.o i2c-proc.o i2c-au1550.o
 
 obj-$(CONFIG_I2C)		+= i2c-core.o
 obj-$(CONFIG_I2C_CHARDEV)	+= i2c-dev.o
@@ -25,6 +25,7 @@
 obj-$(CONFIG_I2C_ALGO_SIBYTE)	+= i2c-algo-sibyte.o i2c-sibyte.o
 obj-$(CONFIG_I2C_MAX1617)	+= i2c-max1617.o
 obj-$(CONFIG_I2C_ALGO_SGI)	+= i2c-algo-sgi.o
+obj-$(CONFIG_I2C_ALGO_AU1550)	+= i2c-algo-au1550.o i2c-au1550.o
 
 # This is needed for automatic patch generation: sensors code starts here
 # This is needed for automatic patch generation: sensors code ends here
diff -Nur linux-2.4.30/drivers/ide/au1xxx/au1xxx-ide.c linux-2.4.30-linux-mips.org/drivers/ide/au1xxx/au1xxx-ide.c
--- linux-2.4.30/drivers/ide/au1xxx/au1xxx-ide.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/ide/au1xxx/au1xxx-ide.c	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,853 @@
+/*
+ * linux/drivers/ide/au1xxx/au1xxx-ide.c	version 0.9	Jan. 28 2005
+ *
+ * BRIEF MODULE DESCRIPTION
+ *	AMD Alchemy Au1xxx IDE interface routines over the Static Bus
+ *
+ * Copyright (c) 2003-2005 AMD, Personal Connectivity Solutions
+ *
+ *  This program is free software; you can redistribute	 it and/or modify it
+ *  under  the terms of	 the GNU General  Public License as published by the
+ *  Free Software Foundation;  either version 2 of the	License, or (at your
+ *  option) any later version.
+ *
+ *  THIS  SOFTWARE  IS PROVIDED	  ``AS	IS'' AND   ANY	EXPRESS OR IMPLIED
+ *  WARRANTIES,	  INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
+ *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
+ *  NO	EVENT  SHALL   THE AUTHOR  BE	 LIABLE FOR ANY	  DIRECT, INDIRECT,
+ *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ *  NOT LIMITED	  TO, PROCUREMENT OF  SUBSTITUTE GOODS	OR SERVICES; LOSS OF
+ *  USE, DATA,	OR PROFITS; OR	BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
+ *  ANY THEORY OF LIABILITY, WHETHER IN	 CONTRACT, STRICT LIABILITY, OR TORT
+ *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  You should have received a copy of the  GNU General Public License along
+ *  with this program; if not, write  to the Free Software Foundation, Inc.,
+ *  675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *  Note: for more information, please refer "AMD Alchemy Au1200/Au1550 IDE
+ *        Interface and Linux Device Driver" Application Note.
+ */
+
+#undef REALLY_SLOW_IO		/* most systems can safely undef this */
+
+#include <linux/config.h>	/* for CONFIG_BLK_DEV_IDEPCI */
+#include <linux/types.h>
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/delay.h>
+#include <linux/timer.h>
+#include <linux/mm.h>
+#include <linux/ioport.h>
+#include <linux/ide.h>
+#include <linux/hdreg.h>
+#include <linux/init.h>
+
+#include <asm/io.h>
+#include <asm/au1000.h>
+#include <asm/au1xxx_dbdma.h>
+
+/*
+ * Platform dependent header files
+ */
+#if defined(CONFIG_MIPS_EP1000)
+#include <asm/ep1000.h>
+
+#elif defined(CONFIG_MIPS_PB1550)
+#include <asm/pb1550.h>
+
+#elif defined(CONFIG_MIPS_DB1550)
+#include <asm/db1x00.h>
+
+#elif defined(CONFIG_MIPS_PB1200)
+#include <asm/pb1200.h>
+
+#elif defined(CONFIG_MIPS_DB1200)
+#include <asm/db1200.h>
+
+#elif defined(CONFIG_MIPS_FICMMP)
+#include <asm/ficmmp.h>
+#endif
+
+#include <linux/config.h>
+
+#if !defined(CONFIG_BLK_DEV_IDE_PIO_AU1XXX)
+
+#if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
+#define DMA_WAIT_TIMEOUT	100
+#define NUM_DESCRIPTORS		64
+#else //CONFIG_BLK_DEV_IDE_PIO_DBDMA_AU1XXX 
+#define NUM_DESCRIPTORS		2
+#endif
+
+typedef struct
+{
+	u32			tx_dev_id, rx_dev_id;
+	u32			tx_chan, rx_chan;
+	void			*tx_desc_head, *rx_desc_head;
+	ide_hwif_t 		*hwif;
+#if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
+	ide_drive_t 		*drive;
+	struct dbdma_cmd	*dma_table_cpu;
+	dma_addr_t		dma_table_dma;
+	struct scatterlist	*sg_table;
+	int			sg_nents;
+	int			sg_dma_direction;
+
+	struct pci_dev 		pcidev;
+	struct pci_bus 		pcibus;
+#endif
+} _auide_hwif;
+
+struct drive_list_entry {
+	char * id_model;
+	char * id_firmware;
+};
+static _auide_hwif auide_hwif;
+
+static struct drive_list_entry dma_black_list[] = {
+	{ "WDC WD100EB-00CGH0"	,	"ALL"		},
+	{ "WDC WD200BB-00AUA1"	,	"ALL"		},
+	{0,0}
+};
+
+#if !defined(AU1XXX_ATA_RQSIZE)
+#define AU1XXX_ATA_RQSIZE	128
+#endif
+#endif /* end !CONFIG_BLK_DEV_IDE_PIO_AU1XXX */
+
+// Boot options
+static int auide_base=KSEG1ADDR(AU1XXX_ATA_PHYS_ADDR);
+static int auide_len=AU1XXX_ATA_PHYS_LEN;
+static int auide_irq=AU1XXX_ATA_INT;
+
+
+/*
+ * local I/O functions
+ */
+u8 auide_inb(unsigned long port)
+{
+	return (au_readb(port));
+}
+
+u16 auide_inw(unsigned long port)
+{
+	return (au_readw(port));
+}
+
+u32 auide_inl(unsigned long port)
+{
+	return (au_readl(port));
+}
+
+void auide_insw(unsigned long port, void *addr, u32 count)
+{
+#if defined(CONFIG_BLK_DEV_IDE_PIO_DBDMA_AU1XXX)
+	_auide_hwif *ahwif = &auide_hwif;
+	chan_tab_t		*ctp;
+	au1x_ddma_desc_t	*dp;
+
+	if(!au1xxx_dbdma_put_dest_flags(ahwif->rx_chan, (void*)addr, count << 1, DDMA_FLAGS_NOIE)) {
+		printk(KERN_ERR "%s failed %d\n", __FUNCTION__, __LINE__);
+		return;
+	}
+        ctp = *((chan_tab_t **)ahwif->rx_chan);
+	dp = ctp->cur_ptr;
+	while (dp->dscr_cmd0 & DSCR_CMD0_V)
+		;
+        ctp->cur_ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
+#else
+	while (count--)
+	{
+		*(u16 *)addr = au_readw(port);
+		addr +=2 ;
+	}
+#endif
+}
+
+void auide_insl(unsigned long port, void *addr, u32 count)
+{
+	while (count--)
+	{
+		*(u32 *)addr = au_readl(port);
+		/* NOTE: For IDE interfaces over PCMCIA, 32-bit access does not work */
+		addr += 4;
+	}
+}
+
+void auide_outb(u8 addr, unsigned long port)
+{
+	return (au_writeb(addr, port));
+}
+
+void auide_outbsync(ide_drive_t *drive, u8 addr, unsigned long port)
+{
+	return (au_writeb(addr, port));
+}
+
+void auide_outw(u16 addr, unsigned long port)
+{
+	return (au_writew(addr, port));
+}
+
+void auide_outl(u32 addr, unsigned long port)
+{
+	return (au_writel(addr, port));
+}
+
+void auide_outsw(unsigned long port, void *addr, u32 count)
+{
+#if defined(CONFIG_BLK_DEV_IDE_PIO_DBDMA_AU1XXX)
+	_auide_hwif *ahwif = &auide_hwif;
+	chan_tab_t		*ctp;
+	au1x_ddma_desc_t	*dp;
+
+	if(!au1xxx_dbdma_put_source_flags(ahwif->tx_chan, (void*)addr, count << 1, DDMA_FLAGS_NOIE)) {
+		printk(KERN_ERR "%s failed %d\n", __FUNCTION__, __LINE__);
+		return;
+	}
+	ctp = *((chan_tab_t **)ahwif->tx_chan);
+	dp = ctp->cur_ptr;
+	while (dp->dscr_cmd0 & DSCR_CMD0_V)
+		;
+        ctp->cur_ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
+#else
+	while (count--)
+	{
+		au_writew(*(u16 *)addr, port);
+		addr += 2;
+	}
+#endif
+}
+
+void auide_outsl(unsigned long port, void *addr, u32 count)
+{
+	while (count--)
+	{
+		au_writel(*(u32 *)addr, port);
+		/* NOTE: For IDE interfaces over PCMCIA, 32-bit access does not work */
+		addr += 4;
+	}
+}
+
+/*
+ * Multi-Word DMA + DDMA functions
+ */
+#if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
+
+static int in_drive_list(struct hd_driveid *id, struct drive_list_entry * drive_table)
+{
+	for ( ; drive_table->id_model ; drive_table++)
+		if ((!strcmp(drive_table->id_model, id->model)) &&
+		    ((strstr(drive_table->id_firmware, id->fw_rev)) ||
+		     (!strcmp(drive_table->id_firmware, "ALL"))))
+			return 1;
+	return 0;
+}
+
+static int auide_build_sglist(ide_hwif_t *hwif, struct request *rq, int data_dir)
+{
+	_auide_hwif *ahwif = (_auide_hwif*)hwif->hwif_data;
+	struct buffer_head *bh;
+	struct scatterlist *sg = ahwif->sg_table;
+	unsigned long lastdataend = ~0UL;
+	int nents = 0;
+
+	ahwif->sg_dma_direction = data_dir;
+
+	if (hwif->sg_dma_active)
+		BUG();
+
+	bh = rq->bh;
+	do {
+		int contig = 0;
+
+		if (bh->b_page) {
+			if (bh_phys(bh) == lastdataend)
+				contig = 1;
+		} else {
+			if ((unsigned long) bh->b_data == lastdataend)
+				contig = 1;
+		}
+
+		if (contig) {
+			sg[nents - 1].length += bh->b_size;
+			lastdataend += bh->b_size;
+			continue;
+		}
+
+		if (nents >= NUM_DESCRIPTORS)
+		{
+			printk(KERN_ERR "%s nents >= NUM_DESCRIPTORS\n", __FUNCTION__);
+			return 0;
+		}
+
+		memset(&sg[nents], 0, sizeof(*sg));
+
+		if (bh->b_page) {
+			sg[nents].page = bh->b_page;
+			sg[nents].offset = bh_offset(bh);
+			lastdataend = bh_phys(bh) + bh->b_size;
+		} else {
+			if ((unsigned long) bh->b_data < PAGE_SIZE)
+				BUG();
+
+			sg[nents].address = bh->b_data;
+			lastdataend = (unsigned long) bh->b_data + bh->b_size;
+		}
+
+		sg[nents].length = bh->b_size;
+		nents++;
+	} while ((bh = bh->b_reqnext) != NULL);
+
+	if(nents == 0)
+		BUG();
+	return pci_map_sg(hwif->pci_dev, sg, nents, data_dir);
+}
+
+static int  auide_raw_build_sglist(ide_hwif_t *hwif, struct request *rq)
+{
+	_auide_hwif *ahwif = (_auide_hwif*)hwif->hwif_data;
+	struct scatterlist *sg = hwif->sg_table;
+	int nents = 0;
+	ide_task_t *args = rq->special;
+	unsigned char *virt_addr = rq->buffer;
+	int sector_count = rq->nr_sectors;
+
+	if (args->command_type == IDE_DRIVE_TASK_RAW_WRITE)
+		ahwif->sg_dma_direction = PCI_DMA_TODEVICE;
+	else
+		ahwif->sg_dma_direction = PCI_DMA_FROMDEVICE;
+
+	if (sector_count > 128) {
+		memset(&sg[nents], 0, sizeof(*sg));
+		sg[nents].address = virt_addr;
+		sg[nents].length = 128  * SECTOR_SIZE;
+		nents++;
+		virt_addr = virt_addr + (128 * SECTOR_SIZE);
+		sector_count -= 128;
+	}
+	memset(&sg[nents], 0, sizeof(*sg));
+	sg[nents].address = virt_addr;
+	sg[nents].length =  sector_count  * SECTOR_SIZE;
+	nents++;
+
+	return pci_map_sg(hwif->pci_dev, sg, nents, ahwif->sg_dma_direction);
+}
+
+static void auide_destroy_dmatable (ide_drive_t *drive)
+{
+	struct pci_dev *dev = HWIF(drive)->pci_dev;
+	ide_hwif_t *hwif = HWIF(drive);
+	_auide_hwif *ahwif = (_auide_hwif*)hwif->hwif_data;
+
+	if (ahwif->sg_nents) {
+		pci_unmap_sg(dev, ahwif->sg_table, ahwif->sg_nents, ahwif->sg_dma_direction);
+		ahwif->sg_nents = 0;
+		HWIF(drive)->sg_dma_active = 0;
+	}
+}
+
+int auide_build_dmatable(ide_drive_t *drive, struct request *rq, int ddir)
+{
+	int i, iswrite, count = 0;
+	ide_hwif_t *hwif = HWIF(drive);
+	_auide_hwif *ahwif = (_auide_hwif*)hwif->hwif_data;
+	struct scatterlist *sg;
+
+	iswrite = (ddir == PCI_DMA_TODEVICE);
+	/* Save for interrupt context */
+	ahwif->drive = drive;
+
+	/* Build sglist */
+	if (rq->cmd == IDE_DRIVE_TASKFILE)
+		ahwif->sg_nents = i = auide_raw_build_sglist(hwif, rq);
+	else
+		ahwif->sg_nents = i = auide_build_sglist(hwif, rq, ddir);
+	if (!i)
+		return 0;
+
+	/* fill the descriptors */
+	sg = ahwif->sg_table;
+	while (i && sg_dma_len(sg)) {
+		u32 cur_addr;
+		u32 cur_len;
+
+		cur_addr = sg_dma_address(sg);
+		cur_len = sg_dma_len(sg);
+
+		while (cur_len) {
+			u32 flags = DDMA_FLAGS_NOIE;
+			unsigned int tc = (cur_len < 0xfe00)? cur_len: 0xfe00;
+
+			if (++count >= PRD_ENTRIES) {
+				printk(KERN_WARNING "%s: DMA table too small\n",
+				       drive->name);
+				goto use_pio_instead;
+			}
+
+			/* Lets enable intr for the last descriptor only */
+			if (1==i)
+				flags = DDMA_FLAGS_IE;
+
+			if (iswrite) {
+				if(!au1xxx_dbdma_put_source_flags(ahwif->tx_chan, (void*)phys_to_virt(cur_addr), tc, flags))
+					printk(KERN_ERR "%s failed %d\n", __FUNCTION__, __LINE__);
+			}
+			else {
+				if(!au1xxx_dbdma_put_dest_flags(ahwif->rx_chan, (void*)phys_to_virt(cur_addr), tc, flags))
+					printk(KERN_ERR "%s failed %d\n", __FUNCTION__, __LINE__);
+			}
+
+			cur_addr += tc;
+			cur_len -= tc;
+		}
+		sg++;
+		i--;
+	}
+	if (count)
+		return 1;
+use_pio_instead:
+	pci_unmap_sg(hwif->pci_dev,
+		     ahwif->sg_table,
+		     ahwif->sg_nents,
+		     ahwif->sg_dma_direction);
+	hwif->sg_dma_active = 0;
+	return 0; /* revert to PIO for this request */
+}
+
+static int auide_dma_end(ide_drive_t *drive)
+{
+	auide_destroy_dmatable(drive);
+	return 0;
+}
+
+int auide_dma_begin(ide_drive_t *drive )
+{
+	return 0;
+}
+
+int auide_dma_read(ide_drive_t *drive)
+{
+	struct request *rq = HWGROUP(drive)->rq;
+	u8 lba48 = (drive->addressing == 1) ? 1 : 0;
+	task_ioreg_t command = WIN_NOP;
+
+	if (!auide_build_dmatable(drive, rq, PCI_DMA_FROMDEVICE)) {
+		/* try PIO instead of DMA */
+		return 1;
+	}
+	drive->waiting_for_dma = 1;
+	if (drive->media != ide_disk)
+		return 0;
+
+	/*
+	 * FIX ME to use only ACB ide_task_t args Struct
+	 */
+	command = (lba48) ? WIN_READDMA_EXT : WIN_READDMA;
+	if (rq->cmd == IDE_DRIVE_TASKFILE) {
+		ide_task_t *args = rq->special;
+		command = args->tfRegister[IDE_COMMAND_OFFSET];
+	}
+
+	/* issue cmd to drive */
+	ide_execute_command(drive, command, &ide_dma_intr, (2*WAIT_CMD), NULL);
+	return auide_dma_begin(drive);
+}
+
+int auide_dma_write(ide_drive_t *drive)
+{
+	struct request *rq = HWGROUP(drive)->rq;
+	u8 lba48 = (drive->addressing == 1) ? 1 : 0;
+	task_ioreg_t command = WIN_NOP;
+
+	if (!auide_build_dmatable(drive, rq, PCI_DMA_TODEVICE))
+		/* try PIO instead of DMA */
+		return 1;
+
+	drive->waiting_for_dma = 1;
+	if (drive->media != ide_disk)
+		return 0;
+	/*
+	 * FIX ME to use only ACB ide_task_t args Struct
+	 */
+	command = (lba48) ? WIN_WRITEDMA_EXT : WIN_WRITEDMA;
+	if (rq->cmd == IDE_DRIVE_TASKFILE) {
+		ide_task_t *args = rq->special;
+		command = args->tfRegister[IDE_COMMAND_OFFSET];
+	}
+
+	/* issue cmd to drive */
+	ide_execute_command(drive, command, &ide_dma_intr, (2*WAIT_CMD), NULL);
+	return auide_dma_begin(drive);
+}
+
+static int auide_dma_count(ide_drive_t *drive)
+{
+	return 0;
+}
+
+static int auide_dma_test_irq(ide_drive_t *drive)
+{
+	if (!drive->waiting_for_dma)
+		printk(KERN_WARNING "%s: ide_dma_test_irq \
+			called while not waiting\n", drive->name);
+
+	/* If dbdma didn't execute the STOP command yet, the
+	 * active bit is still set */
+	drive->waiting_for_dma++;
+	if (drive->waiting_for_dma >= DMA_WAIT_TIMEOUT) {
+		printk(KERN_WARNING "%s: timeout waiting for ddma to complete\n", drive->name);
+		return 1;
+	}
+	udelay(10);
+	return 0;
+}
+
+static int auide_dma_host_off(ide_drive_t *drive)
+{
+	return 0;
+}
+
+static int auide_dma_host_on(ide_drive_t *drive)
+{
+	return 0;
+}
+
+static int auide_dma_lostirq(ide_drive_t *drive)
+{
+	return 0;
+}
+
+static int auide_dma_on(ide_drive_t *drive)
+{
+	/*
+		Is the drive in our DMA black list?
+	 */
+	if ( in_drive_list(drive->id, dma_black_list ) ) {
+		drive->using_dma = 0;
+		printk("%s found in dma_blacklist[]! Disabling DMA.\n", drive->id->model);
+	}
+	else 
+		drive->using_dma = 1;
+
+	return HWIF(drive)->ide_dma_host_on(drive);
+}
+
+static void auide_ddma_tx_callback(int irq, void *param, struct pt_regs *regs)
+{
+	_auide_hwif *ahwif = (_auide_hwif*)param;
+	ahwif->drive->waiting_for_dma = 0;
+	return;
+}
+
+static void auide_ddma_rx_callback(int irq, void *param, struct pt_regs *regs)
+{
+	_auide_hwif *ahwif = (_auide_hwif*)param;
+	ahwif->drive->waiting_for_dma = 0;
+	return;
+}
+#endif /* end CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX */
+
+#if !defined(CONFIG_BLK_DEV_IDE_PIO_AU1XXX)
+static int auide_ddma_init( _auide_hwif *auide )
+{
+	dbdev_tab_t dev;
+#if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
+	ide_hwif_t *hwif = auide->hwif;
+#endif
+	/* Add our custom device to DDMA device table */
+	/* Create our new device entries in the table */
+#if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
+	dev.dev_id = AU1XXX_ATA_DDMA_REQ;
+#else
+	dev.dev_id = DSCR_CMD0_ALWAYS;
+#endif
+	dev.dev_flags = DEV_FLAGS_OUT|DEV_FLAGS_SYNC|DEV_FLAGS_BURSTABLE;
+
+	dev.dev_tsize = 8;
+	dev.dev_devwidth = 32;
+
+	dev.dev_physaddr = (u32)AU1XXX_ATA_PHYS_ADDR;
+	dev.dev_intlevel = 0;
+	dev.dev_intpolarity = 0;
+	auide->tx_dev_id = au1xxx_ddma_add_device( &dev );
+
+	dev.dev_flags = DEV_FLAGS_IN|DEV_FLAGS_SYNC|DEV_FLAGS_BURSTABLE;
+	auide->rx_dev_id = au1xxx_ddma_add_device( &dev );
+
+#if  defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
+	/* Get a channel for TX */
+	auide->tx_chan = au1xxx_dbdma_chan_alloc( DSCR_CMD0_ALWAYS, auide->tx_dev_id, auide_ddma_tx_callback, (void*)auide );
+	/* Get a channel for RX */
+	auide->rx_chan = au1xxx_dbdma_chan_alloc( auide->rx_dev_id, DSCR_CMD0_ALWAYS, auide_ddma_rx_callback, (void*)auide );
+#else	/* CONFIG_BLK_DEV_IDE_PIO_DBDMA_AU1XXX */
+	/*
+	 * Note: if call back is not enabled, update ctp->cur_ptr manually 
+	 */
+	auide->tx_chan = au1xxx_dbdma_chan_alloc( DSCR_CMD0_ALWAYS, auide->tx_dev_id, NULL, (void*)auide );
+	auide->rx_chan = au1xxx_dbdma_chan_alloc( auide->rx_dev_id, DSCR_CMD0_ALWAYS, NULL, (void*)auide );
+#endif
+	auide->tx_desc_head = (void*)au1xxx_dbdma_ring_alloc( auide->tx_chan, NUM_DESCRIPTORS );
+	auide->rx_desc_head = (void*)au1xxx_dbdma_ring_alloc( auide->rx_chan, NUM_DESCRIPTORS );
+
+#if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
+	hwif->dmatable_cpu = pci_alloc_consistent(hwif->pci_dev,
+						  PRD_ENTRIES * PRD_BYTES,	/* 1 Page */
+						  &hwif->dmatable_dma);
+
+	auide->sg_table = kmalloc(sizeof(struct scatterlist) * PRD_ENTRIES,
+				 GFP_KERNEL|GFP_DMA);
+	if (auide->sg_table == NULL) {
+		return -ENOMEM;
+	}
+
+	hwif->ide_dma_off 		= &__ide_dma_off;
+	hwif->ide_dma_off_quietly	= &__ide_dma_off_quietly;
+	hwif->ide_dma_good_drive 	= &__ide_dma_good_drive;
+	hwif->ide_dma_bad_drive 	= &__ide_dma_bad_drive;
+	hwif->ide_dma_verbose 		= &__ide_dma_verbose;
+	hwif->ide_dma_timeout 		= &__ide_dma_timeout;
+	hwif->ide_dma_retune 		= &__ide_dma_retune;
+
+	hwif->ide_dma_check			= &__ide_dma_check;
+	hwif->ide_dma_read		= &auide_dma_read;
+	hwif->ide_dma_write		= &auide_dma_write;
+	hwif->ide_dma_count		= &auide_dma_count;
+	hwif->ide_dma_begin		= &auide_dma_begin;
+	hwif->ide_dma_end		= &auide_dma_end;
+	hwif->ide_dma_test_irq		= &auide_dma_test_irq;
+	hwif->ide_dma_host_off		= &auide_dma_host_off;
+	hwif->ide_dma_host_on		= &auide_dma_host_on;
+	hwif->ide_dma_lostirq 		= &auide_dma_lostirq;
+	hwif->ide_dma_on		= &auide_dma_on;
+#endif
+	au1xxx_dbdma_start( auide->tx_chan );
+	au1xxx_dbdma_start( auide->rx_chan );
+	return 0;
+}
+#endif /* end DMA + Dbdma || PIO + Dbdma*/
+
+static void auide_setup_ports(hw_regs_t *hw)
+{
+	int i;
+	ide_ioreg_t *ata_regs = hw->io_ports;
+
+	for (i = 0; i < IDE_CONTROL_OFFSET; i++)
+		*ata_regs++ = (ide_ioreg_t) auide_base + (ide_ioreg_t)(i << AU1XXX_ATA_REG_OFFSET);
+	/* set the Alternative Status register */
+	*ata_regs = (ide_ioreg_t) auide_base + (ide_ioreg_t)(14 << AU1XXX_ATA_REG_OFFSET);
+}
+
+/*
+ * The following routines are all that is needed to utilize the
+ * IDE subsystems' generic PIO driver with an IDE interface on
+ * the Au1xxx static bus. The only items required are a *valid*
+ * base address and IRQ. Note that when PCI is enabled, the
+ * mips_io_offset utilized in the INB/OUTB and likes changes
+ * and can cause this to no longer work.
+ */
+static int auide_default_irq(ide_ioreg_t base)
+{
+	switch (base) {
+		case KSEG1ADDR(AU1XXX_ATA_PHYS_ADDR): return ((int)auide_irq);
+		case 0x1f0: return 14;
+		case 0x170: return 15;
+		case 0x1e8: return 11;
+		case 0x168: return 10;
+		case 0x1e0: return 8;
+//		case 0x160: return 12;
+		default:
+			return 0;
+	}
+}
+
+static ide_ioreg_t auide_default_io_base(int index)
+{
+	switch (index) {
+		case 0:	return ((ide_ioreg_t)auide_base);
+		case 1:	return 0x1f0;
+		case 2:	return 0x170;
+		case 3: return 0x1e8;
+		case 4: return 0x168;
+		case 5: return 0x1e0;
+//		case 5: return 0x160;
+		default:
+			return 0;
+	}
+}
+
+static void auide_init_hwif_ports (hw_regs_t *hw, ide_ioreg_t data_port,
+			    ide_ioreg_t ctrl_port, int *irq)
+{
+	ide_ioreg_t reg = data_port;
+	int i;
+
+	/* claim the first hwif for the Au1xxx IDE driver */
+	if (reg == auide_base) {
+		if (!auide_base)
+		{
+			printk(KERN_ERR "%s Null auide_base, data_port=%x\n", __FUNCTION__, (unsigned int)data_port);
+			return;
+		}
+		auide_setup_ports(hw);
+
+		if (irq != NULL)
+			*irq = (int)auide_irq;
+	}
+	else {
+		for (i = IDE_DATA_OFFSET; i <= IDE_STATUS_OFFSET; i++) {
+			hw->io_ports[i] = reg;
+			reg += 1;
+		}
+		if (ctrl_port) {
+			hw->io_ports[IDE_CONTROL_OFFSET] = ctrl_port;
+		} else {
+			hw->io_ports[IDE_CONTROL_OFFSET] = hw->io_ports[IDE_DATA_OFFSET] + 0x206;
+		}
+		if (irq != NULL)
+			*irq = 0;
+		hw->io_ports[IDE_IRQ_OFFSET] = 0;
+	}
+}
+
+struct ide_ops auide_ops = {
+	auide_default_irq,
+	auide_default_io_base,
+	auide_init_hwif_ports,
+};
+
+int __init auide_probe(void)
+{
+	ide_hwif_t *hwif;;
+	hw_regs_t hw;
+	int i=0;
+
+	if (!auide_base || !auide_len || (auide_irq <= 0))
+		return -ENODEV;
+
+	if (!request_mem_region (auide_base, auide_len, "Au1xxx IDE")) {
+		printk (KERN_ERR "controller already in use");
+		return -EBUSY;
+	}
+
+#if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
+	memset(&auide_hwif, 0, sizeof(_auide_hwif));
+	/* PCI is used to for API simplicity -- no real device present */
+	strcpy(auide_hwif.pcidev.name, "non-PCI Au1xxx IDE");
+	strcpy(auide_hwif.pcidev.slot_name, "builtin");
+	auide_hwif.pcibus.parent = NULL;
+	auide_hwif.pcibus.parent = NULL;
+	auide_hwif.pcidev.bus = &auide_hwif.pcibus;
+	auide_hwif.pcidev.irq = auide_irq;
+#endif
+	memset(&hw, 0, sizeof(hw));
+	auide_setup_ports(&hw);
+
+	/* register hwif */
+	if ((i = ide_register_hw(&hw, NULL)) < 0)
+	{
+		printk(KERN_DEBUG "%s could not register ide i/f\n", __FUNCTION__);
+		return -ENODEV;
+	}
+	hwif = &ide_hwifs[i];
+
+	hwif->chipset = ide_au1xxx;
+
+#if defined(CONFIG_BLK_DEV_IDE_SEQTS_PER_RQ_AU1XXX)
+	hwif->rqsize = CONFIG_BLK_DEV_IDE_SEQTS_PER_RQ_AU1XXX;
+	hwif->rqsize = ((hwif->rqsize > AU1XXX_ATA_RQSIZE) || (hwif->rqsize < 32)) ? AU1XXX_ATA_RQSIZE : hwif->rqsize;
+#else // if kernel config is not set
+	hwif->rqsize = AU1XXX_ATA_RQSIZE;
+#endif
+
+	hwif->ultra_mask = 0x0;		 /* Disable Ultra DMA */
+#if !defined(CONFIG_BLK_DEV_IDE_PIO_AU1XXX)
+	hwif->mwdma_mask = 0x07;	/* Multimode-2 DMA  */
+	hwif->swdma_mask = 0x07;
+#else
+	hwif->mwdma_mask = 0x0;
+	hwif->swdma_mask = 0x0;
+#endif
+	hwif->noprobe = !hwif->io_ports[IDE_DATA_OFFSET];
+	hwif->drives[0].unmask = 1;
+	hwif->drives[1].unmask = 1;
+
+	/* hold should be on in all cases */
+	hwif->hold = 1;
+	hwif->mmio = 1;
+
+	/* set up local I/O function entry points */
+	hwif->INB = auide_inb;
+	hwif->INW = auide_inw;
+	hwif->INL = auide_inl;
+	hwif->INSW = auide_insw;
+	hwif->INSL = auide_insl;
+	hwif->OUTB = auide_outb;
+	hwif->OUTBSYNC = auide_outbsync;
+	hwif->OUTW = auide_outw;
+	hwif->OUTL = auide_outl;
+	hwif->OUTSW = auide_outsw;
+	hwif->OUTSL = auide_outsl;
+
+#if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
+	hwif->autodma = 1;
+	hwif->drives[0].autodma = 1;
+	hwif->drives[1].autodma = 1;
+	hwif->atapi_dma = 1;
+	hwif->drives[0].using_dma = 1;
+	hwif->drives[1].using_dma = 1;
+#else /* !CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX */
+	hwif->autodma = 0;
+	hwif->channel = 0;
+	hwif->hold = 1;
+	hwif->select_data = 0;	/* no chipset-specific code */
+	hwif->config_data = 0;	/* no chipset-specific code */
+
+	hwif->drives[0].autodma = 0;
+	hwif->drives[0].drive_data = 0;	/* no drive data */
+	hwif->drives[0].using_dma = 0;
+	hwif->drives[0].waiting_for_dma = 0;
+	hwif->drives[0].autotune = 2;
+	/* secondary hdd not supported */
+	hwif->drives[1].autodma = 0;
+
+	hwif->drives[1].drive_data = 0;
+	hwif->drives[1].using_dma = 0;
+	hwif->drives[1].waiting_for_dma = 0;
+	hwif->drives[1].autotune = 2;
+#endif
+	hwif->drives[0].io_32bit = 0;	/* 0=16-bit, 1=32-bit, 2/3=32bit+sync */
+	hwif->drives[1].io_32bit = 0;	/* 0=16-bit, 1=32-bit, 2/3=32bit+sync */
+
+#if !defined(CONFIG_BLK_DEV_IDE_PIO_AU1XXX)
+	auide_hwif.hwif = hwif;
+	hwif->hwif_data = &auide_hwif;
+	auide_ddma_init(&auide_hwif);
+#endif
+	return 0;
+}
+
+static int __init auide_setup (char* options)
+{
+	char* this_opt;
+
+	if (!options || !*options)
+		return 0;
+
+	for(this_opt=strtok(options,",");this_opt;this_opt=strtok(NULL,",")) {
+		if (!strncmp(this_opt, "base:", 5)) {
+			auide_base = simple_strtoul(this_opt+5, NULL, 0);
+		} else if (!strncmp(this_opt, "len:", 4)) {
+			auide_len = simple_strtoul(this_opt+4, NULL, 0);
+		} else if (!strncmp(this_opt, "irq:", 4)) {
+			auide_irq = simple_strtoul(this_opt+4, NULL, 0);
+		}
+	}
+
+	return 0;
+}
+__setup("auide=", auide_setup);
+
+EXPORT_NO_SYMBOLS;
diff -Nur linux-2.4.30/drivers/ide/au1xxx/Makefile linux-2.4.30-linux-mips.org/drivers/ide/au1xxx/Makefile
--- linux-2.4.30/drivers/ide/au1xxx/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/ide/au1xxx/Makefile	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,10 @@
+O_TARGET := au1xxx-idedriver.o
+
+obj-y		:=
+obj-m		:=
+
+obj-$(CONFIG_BLK_DEV_IDE_AU1XXX)	+= au1xxx-ide.o
+
+EXTRA_CFLAGS	:= -I../
+
+include $(TOPDIR)/Rules.make
diff -Nur linux-2.4.30/drivers/ide/Config.in linux-2.4.30-linux-mips.org/drivers/ide/Config.in
--- linux-2.4.30/drivers/ide/Config.in	2004-11-17 12:54:21.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/ide/Config.in	2005-05-12 18:01:29.000000000 +0200
@@ -9,6 +9,7 @@
 dep_tristate 'Enhanced IDE/MFM/RLL disk/cdrom/tape/floppy support' CONFIG_BLK_DEV_IDE $CONFIG_IDE
 comment 'Please see Documentation/ide.txt for help/info on IDE drives'
 if [ "$CONFIG_BLK_DEV_IDE" != "n" ]; then
+
    dep_bool '  Use old disk-only driver on primary interface' CONFIG_BLK_DEV_HD_IDE $CONFIG_X86
    define_bool CONFIG_BLK_DEV_HD $CONFIG_BLK_DEV_HD_IDE
 
@@ -87,6 +88,15 @@
 	    fi
          fi
       fi
+      if [ "$CONFIG_SOC_AU1X00" = "y" ]; then
+         dep_bool '    Builtin AMD Alchemy Au1xxx IDE support' CONFIG_BLK_DEV_IDE_AU1XXX $CONFIG_BLK_DEV_IDEPCI
+         dep_bool '      PIO mode' CONFIG_BLK_DEV_IDE_PIO_AU1XXX $CONFIG_BLK_DEV_IDE_AU1XXX
+         dep_bool '      PIO mode with DDMA assists' CONFIG_BLK_DEV_IDE_PIO_DBDMA_AU1XXX $CONFIG_BLK_DEV_IDE_AU1XXX
+         dep_bool '      Multiword DMA mode with DDMA assists' CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX $CONFIG_BLK_DEV_IDE_AU1XXX
+         if [ "$CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX" = "y" ]; then
+            int '      Maximum transfer size (KB) per request (up to 128)' CONFIG_BLK_DEV_IDE_SEQTS_PER_RQ_AU1XXX 128
+         fi
+      fi
       if [ "$CONFIG_ALL_PPC" = "y" ]; then
 	 bool '    Builtin PowerMac IDE support' CONFIG_BLK_DEV_IDE_PMAC
 	 dep_bool '      Probe internal Kauai ATA/100 first' CONFIG_BLK_DEV_IDE_PMAC_ATA100FIRST $CONFIG_BLK_DEV_IDE_PMAC
